#ifndef LOAD_OFFSET
#define LOAD_OFFSET 0
#endif

#ifndef C_SYMBOL_PREFIX
#define C_SYMBOL_PREFIX
#endif

#define __paste(x,y) x##y
#define _paste(x,y) __paste(x,y)
#define CSYM(name) _paste(C_SYMBOL_PREFIX,name)

/* Section contents for read-only data.  */
#define RODATA_CONTENTS							      \
		*(.rodata) *(.rodata.*)					      \
		*(__vermagic)		/* Kernel version magic */	      \
		*(.rodata1)						      \
	/* Kernel symbol table: Normal symbols */			      \
	CSYM(__start___ksymtab) = .;					      \
		*(__ksymtab)						      \
	CSYM(__stop___ksymtab) = .;					      \
	/* Kernel symbol table: GPL-only symbols */			      \
	CSYM(__start___gpl_ksymtab) = .;				      \
		*(__gpl_ksymtab)					      \
	CSYM(__stop___gpl_ksymtab) = .;					      \
	/* Kernel symbol table: strings */				      \
		*(__ksymtab_strings)

/* A standalone section containing RODATA_CONTENTS.  */
#define RODATA_SECTION							      \
	.rodata           : AT(ADDR(.rodata) - LOAD_OFFSET) {		      \
		RODATA_CONTENTS						      \
	}
